package com.citygis.web.service.impl;

import com.citygis.web.service.SingleLoginService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;

/**
 * @Author: zyl
 * @CreateTime: 2025-02-05
 * @Description: 单点登录
 * @Version: 1.0
 */
@Service
@Slf4j
public class SingleLoginServiceImpl implements SingleLoginService {

    @Value("${singleLogin.ssoRet}")
    private String ssoRet;

    @Value("${singleLogin.clientId}")
    private String clientId;

    @Value("${singleLogin.url}")
    private String url;

    @Override
    public void singleLogin(HttpServletRequest request, HttpServletResponse response) throws IOException {

        //拼接url，ssoRet为派拉请求登陆认证地址，redirect_uri为跳转应用地址
        String returnURL = ssoRet +
                "client_id=" + clientId + "&" +
                "response_type=code" +
                "&redirect_uri=" + URLEncoder.encode(url, StandardCharsets.UTF_8.toString()) +
                "&oauth_timestamp=" + System.currentTimeMillis();

        log.info("成功------>" + returnURL);

        response.sendRedirect(returnURL);
    }
}
